#!/bin/bash

progname="Bulk Mail Sender."
version="1.0.1 / 2023"

# Current Date
C_DATE=$(date +'%Y-%m-%d')

# Current Time
C_TIME=$(date +'%H:%M')

# ? ? ? X-Mailer: CheetahMailer
#       X-mailer: nlserver, Build 6.7.0

LINK="v-url.net"

MESSAGE="letter.txt"

function send_bulk {
    for ADDRESSEE in `cat list.txt`; do

    #
    # Variables for every email send.
    #

    # Random Security Code to replace inside every Message.
    # Random Code to replace inside id="" and <!-- -->
    R_COD1=$(tr -dc 0-9 </dev/urandom |  head -c 5)
    R_COD2=$(tr -dc 0-9 </dev/urandom |  head -c 4)
    R_COD3=$(tr -dc 0-9 </dev/urandom |  head -c 3)
    
    # Random generated boundary
    R_BO1=$(tr -dc 0-9 </dev/urandom |  head -c 5)
    R_BO2=$(tr -dc 0-9 </dev/urandom |  head -c 4)
    R_BO3=$(tr -dc 0-9 </dev/urandom |  head -c 3)
    R_BO_MSG="$R_BO2-$R_BO3-$R_BO1"
   
    # Random First Name for FROM Header
    FN_NMB=$[ ( $RANDOM % 1985 ) + 1 ];
    R_FN=`awk -v r=$FN_NMB ' NR==r {print} ' ./inc/f_names.txt`;

    # Random Last Name for FROM Header
    LN_NMB=$[ ( $RANDOM % 1000 ) + 1 ];
    R_LN=`awk -v r=$LN_NMB ' NR==r {print} ' ./inc/l_names.txt`;
    
    # Random CTE (Content-Transfer-Encoding) from list for every Message
    CTE=$[ ( $RANDOM % 4 ) + 1 ];
    R_CTE=$(awk -v r=$CTE ' NR==r {print} ' ./inc/cte.txt);
    
    # Link to replace (click location + images location)
    LINKS=$[ ( $RANDOM % 1 ) + 1 ];
    S_LINK=$(awk -v r=$LINKS ' NR==r {print} ' ./inc/links.txt);
    SLINK="$S_LINK"
    CLINK=$(echo $LINK |cut -d"/" -f3)

    # Extract HOSTNAME
    HOST=$(echo $HOSTNAME)
    
    # Generated From field
    G_FROM="Poste.it <$R_FN.$R_LN@$HOST>"

    # Random Subject
    SUB=$[ ( $RANDOM % 5 ) + 1 ];
    R_SUB=$(awk -v r=$SUB ' NR==r {print} ' ./inc/subject.txt);
    R_SUBJECT="$R_SUB"
    
    PNAME="bsend"
    TEMP_FILE=./${PNAME}.$R_COD1

        echo "#!/bin/sh" > $TEMP_FILE
        echo "/usr/sbin/sendmail -t <<- -EndOfMail-" >> $TEMP_FILE

    # Headers
#       echo "Return-Path: <bounce-$R_COD1$R_COD3$R_COD2@$HOST>" >> $TEMP_FILE
        echo "X-Report-Abuse: Please report spam/abuse here: complains@$HOST" >> $TEMP_FILE
        echo "X-CSA-Complaints: whitelist-complaints@eco.de" >> $TEMP_FILE
        echo "List-Unsubscribe-Post: List-Unsubscribe=One-Click" >> $TEMP_FILE
        echo "Reply-To: <replay-$R_COD1$R_COD3$R_COD2@$HOST>" >> $TEMP_FILE
        echo "From: $G_FROM" >> $TEMP_FILE
        echo "To: $ADDRESSEE" >> $TEMP_FILE
#       echo "Message-Id: $R_COD1$R_COD3$R_COD2@$HOST" >> $TEMP_FILE
        echo "Subject: $R_SUBJECT" >> $TEMP_FILE
        echo "MIME-Version: 1.0" >> $TEMP_FILE
        echo "Content-Type: multipart/alternative; boundary=\"----=_Part_$R_BO_MSG\"" >> $TEMP_FILE
        echo "List-Unsubscribe: <http://$HOST/i/unsubscribe/$R_COD1$R_COD3$R_COD2>, <mailto:unsubscribe-$R_COD1$R_COD3$R_COD2@$HOST?subject=unsubscribe>" >> $TEMP_FILE
        echo "" >> $TEMP_FILE

    # Message body (Text + HTML)
        # TEXT
        echo "------=_Part_$R_BO_MSG" >> $TEMP_FILE
        echo "Content-Type: text/plain; charset=utf-8" >> $TEMP_FILE
        echo "Content-Transfer-Encoding: $R_CTE" >> $TEMP_FILE
        echo "" >> $TEMP_FILE
        echo "In order to read this message correctly you need a Email Client that supports text/HTML format." >> $TEMP_FILE
        echo "Thank you." >> $TEMP_FILE
        echo "" >> $TEMP_FILE
        # HTML
        echo "------=_Part_$R_BO_MSG" >> $TEMP_FILE
        echo "Content-Type: text/html; charset=utf-8" >> $TEMP_FILE
        echo "Content-Transfer-Encoding: $R_CTE" >> $TEMP_FILE
        echo "" >> $TEMP_FILE
        cat $MESSAGE >> $TEMP_FILE
        echo "" >> $TEMP_FILE
        echo "------=_Part_$R_BO_MSG--" >> $TEMP_FILE

    # Replacing with Randoms
        sed "s/SECR/$R_COD1-$R_COD2-$R_COD3/g" $TEMP_FILE > sed-temp.txt          # Changing generated code in ID="",  <!-- --> and access Key
        mv -f sed-temp.txt $TEMP_FILE 2>/dev/null
        sed "s/EMAIL/$ADDRESSEE/g" $TEMP_FILE > sed-temp.txt                      # Changing email with the one we are sending
        mv -f sed-temp.txt $TEMP_FILE 2>/dev/null
        sed "s/LDATE/$C_DATE/g" $TEMP_FILE > sed-temp.txt                         # Changing Local Date with time the email was send
        mv -f sed-temp.txt $TEMP_FILE 2>/dev/null
        sed "s/LTIME/$C_TIME/g" $TEMP_FILE > sed-temp.txt                         # Changing Local Time with time the email was send
        mv -f sed-temp.txt $TEMP_FILE 2>/dev/null
        sed "s/LINK/$LINK/g" $TEMP_FILE > sed-temp.txt                            # Changing Link with our own
        mv -f sed-temp.txt $TEMP_FILE 2>/dev/null
        sed "s/SINK/$SLINK/g" $TEMP_FILE > sed-temp.txt                            # Changing Link with our own
        mv -f sed-temp.txt $TEMP_FILE 2>/dev/null
        rm -rf sed-temp.txt 2>/dev/null
        echo "" >> $TEMP_FILE

    # End of email + Script runner
        echo "-EndOfMail-" >> $TEMP_FILE
        echo "" >> $TEMP_FILE
        chmod +x $TEMP_FILE
        $TEMP_FILE
        rm -f $TEMP_FILE
        echo "Message sent OK to $ADDRESSEE"
    done
}

function clean_up {
    rm -f bsend* 2>/dev/null
}

function graceful_exit {
    clean_up
    exit
}
    echo " "
    echo "[+] Program Name : $progname"
    echo "[+] Program Version : $version"
    echo " "
    send_bulk
    echo " "
    graceful_exit
